
#include "vorgabe.hpp"

#include <ios>
#include <iostream>

int main() {
    std::cout << std::boolalpha;

    std::cout << "# create and fill:" << std::endl;
    Deque<int> deque {};
    deque.enqueueBack(2);
    deque.enqueueBack(3);
    deque.enqueueBack(4);
    deque.enqueueFront(1);
    deque.enqueueFront(0);
    deque.enqueueBack(5);
    deque.enqueueBack(6);
    deque.enqueueFront(-1);
    deque.print();
    deque.printReversed();
    std::cout << "should be: " << std::endl;
    std::cout << "[ (-1) (0, 1) (2, 3) (4, 5) (6) ] 8" << std::endl;
    std::cout << "[ (6) (5, 4) (3, 2) (1, 0) (-1) ] 8" << std::endl;

    std::cout << "\n# test dequeue:" << std::endl;
    deque.print();
    std::cout << "dequeueBack: " << deque.dequeueBack().value() << std::endl;
    deque.print();
    std::cout << "dequeueBack: " << deque.dequeueBack().value() << std::endl;
    deque.print();
    std::cout << "dequeueFront: " << deque.dequeueFront().value() << std::endl;
    deque.print();
    std::cout << "dequeueFront: " << deque.dequeueFront().value() << std::endl;
    deque.print();
    deque.printReversed();
    std::cout << "should be:" << std::endl;
    std::cout << "[ (1) (2, 3) (4) ] 4" << std::endl;
    std::cout << "[ (4) (3, 2) (1) ] 4" << std::endl;

    std::cout << "\n# fill it again" << std::endl;
    deque.enqueueBack(5);
    deque.enqueueBack(6);
    deque.enqueueBack(7);
    deque.enqueueBack(8);
    deque.print();
    deque.printReversed();

    std::cout << "\n# test removal:" << std::endl;
    deque.print();
    std::cout << "removed at 2: " << deque.removeAt(2).value() << std::endl;
    deque.print();
    std::cout << "removed at 5: " << deque.removeAt(5).value() << std::endl;
    deque.print();
    std::cout << "removed at 5: " << deque.removeAt(5).value() << std::endl;
    deque.print();
    std::cout << "removed at 0: " << deque.removeAt(0).value() << std::endl;
    deque.print();
    std::cout << "removed at 4: " << deque.removeAt(4).has_value() << std::endl;
    deque.print();
    deque.printReversed();
    std::cout << "should be:" << std::endl;
    std::cout << "[ (2) (4, 5) (6) ] 4" << std::endl;
    std::cout << "[ (6) (5, 4) (2) ] 4" << std::endl;

    std::cout << "\n# test insertion:" << std::endl;
    std::cout << "inserting 22 at 2: " << deque.insertAt(2, 11) << std::endl;
    deque.print();
    std::cout << "inserting 11 at 0: " << deque.insertAt(0, 22) << std::endl;
    deque.print();
    std::cout << "inserting 11 at 6: " << deque.insertAt(6, 33) << std::endl;
    deque.print();
    std::cout << "inserting 11 at 20 (should return false): " << deque.insertAt(20, 11)
              << std::endl;
    deque.print();
    deque.printReversed();
    std::cout << "should be:" << std::endl;
    std::cout << "[ (22, 2) (4, 11) (5) (6, 33) ] 7" << std::endl;
    std::cout << "[ (33, 6) (5) (11, 4) (2, 22) ] 7" << std::endl;
}
